#ifndef MYX_REDIS_CLIENT_P_HPP_
#define MYX_REDIS_CLIENT_P_HPP_

#include <myx/redis/client.hpp>
#include <myx/redis/lexer.hpp>
#include <myx/redis/parser.hpp>
#include <myx/redis/reply.hpp>
#include <myx/redis/request.hpp>

#include <QObject>
#include <QQueue>
#include <QTcpSocket>

namespace myx {

namespace redis {

class ClientPrivate : public QObject
{
	Q_OBJECT

public:
	explicit ClientPrivate( Client* = nullptr );

	QTcpSocket         socket;
	QQueue< Request* > queue;

	Lexer  lexer;
	Parser parser;

private:
	Q_SLOT void sendReply( const myx::redis::Reply& );
}; // class ClientPrivate

} // namespace redis

} // namespace myx

#endif // MYX_REDIS_CLIENT_P_HPP_
